;*
;* Title:		    
;*			  
;* Version:		2.00
;* Target:		AT90S2313
;* Xtal:		6,144 MHz

.include "Init.asm"
.include "MainLoop.asm"

;******************************************************************************
;  	Subroutines Area
;******************************************************************************
.include "button.asm"

	
;******************************************************************************
;	Interrupt Handl
;******************************************************************************
;     ,   
;******************************************************************************
Phase:
	in	pres,SREG	;  
	push	temp
	
	cbi	PORTB,1		;
	
	in	temp,PORTB
	cbr	temp,0b11111000
	out	PORTB,temp	;  
	clr	temp
	out	TCNT0,temp	; 
	
	sei
	
;******************************************************************************
;         
;******************************************************************************
	
	bbrc	Flag1,All_On,PUP_0	
	
;******************************************************************************
;      
;******************************************************************************
All_On_1:
;	bbrs	FLAG,All_first,AllOn0
	;***   ***
;	stbr	FLAG,All_first
	ser	mask
AllOn0:	
	tst	br1
	breq	AllOn1
	dec	br1
AllOn1:	
	tst	br2
	breq	AllOn2
	dec	br2
AllOn2:	
	tst	br3
	breq	AllOn3
	dec	br3
AllOn3:	
	tst	br4
	breq	AllOn4
	dec	br4
AllOn4:	
	tst	br5
	breq	AllOn5
	dec	br5
AllOn5:	
	clr	temp
	or	temp,br1
	or	temp,br2
	or	temp,br3
	or	temp,br4
	or	temp,br5
	tst	temp
	brne	PUP_0
	;***        ***
	clbr	Flag1,All_On
;	clbr	FLAG,All_first
	clr	Dir
	
;******************************************************************************
;      , , ,  
;******************************************************************************
PUP_0:
	bbrc	Flag1,Resiv_Complit,RC_exit
PUP_1:
	cpi	Frame,1
	brne	PUP_2		;  ,  
	
	;***    ***
	clr	Frame		; ,   
	clbr	Flag1,Resiv_Complit;   
	rcall	Restore_10h	; 10   
	
	;***   ***
	tst	IR_cnt		;  , ,  
	brne	PUP_1_1		;   ?
	clr	temp		;  
	stbr	temp,SYM1	;   
	eor	Dir,temp	;
PUP_1_1:
	ldi	temp,IR_time	;   
	mov	IR_cnt,temp
	
	bbrs	Dir,SYM1,IR_Off1;    
	
	;***   ***
IR_ON1:
	stbr	mask,SYM1
	
	ldi	temp,IR_step
	sub	br1,temp
	breq	END_IR_ON1
	brcs	END_IR_ON1
	rjmp	RC_exit
END_IR_ON1:
	clr	br1
	rjmp	RC_exit

	;***   ***
IR_Off1:	
	mov	temp,br1
	cpi	temp,min_br
	brsh	END_IR_Off1	;    ,  
	ldi	temp,IR_step
	add	br1,temp	;  
	rjmp	RC_exit		; 
END_IR_Off1:
	clbr	mask,SYM1
	rjmp	RC_exit	
	
;******************************************************************************		
PUP_2:
	cpi	Frame,2
	brne	PUP_3		;  ,  
	
	;***    ***
	clr	Frame		; ,   
	clbr	Flag1,Resiv_Complit;   
	rcall	Restore_10h	; 10  
	
	;***   ***
	tst	IR_cnt		;  , ,  
	brne	PUP_2_1		;   ?
	clr	temp		;  
	stbr	temp,SYM2	;   
	eor	Dir,temp	;
PUP_2_1:
	ldi	temp,IR_time	;   
	mov	IR_cnt,temp
	
	bbrs	Dir,SYM2,IR_Off2;    
	
	;***   ***
IR_ON2:
	stbr	mask,SYM2
	ldi	temp,IR_step
	sub	br2,temp
	breq	END_IR_ON2
	brcs	END_IR_ON2
	rjmp	RC_exit
END_IR_ON2:
	clr	br2
	rjmp	RC_exit

	;***   ***
IR_Off2:	
	mov	temp,br2
	cpi	temp,min_br
	brsh	END_IR_Off2	;    ,  
	ldi	temp,IR_step
	add	br2,temp	;  
	rjmp	RC_exit		; 
END_IR_Off2:
	clbr	mask,SYM2
	rjmp	RC_exit
	
;******************************************************************************	
PUP_3:
	cpi	Frame,3
	brne	PUP_4		;  ,  
	
	;***    ***
	clr	Frame		; ,   
	clbr	Flag1,Resiv_Complit;   
	rcall	Restore_10h	; 10  
	
	;***   ***
	tst	IR_cnt		;  , ,  
	brne	PUP_3_1		;   ?
	clr	temp		;  
	stbr	temp,SYM3	;   
	eor	Dir,temp	;
PUP_3_1:
	ldi	temp,IR_time	;   
	mov	IR_cnt,temp
	
	bbrs	Dir,SYM3,IR_Off3;    
	
	;***   ***
IR_ON3:
	stbr	mask,SYM3
	ldi	temp,IR_step
	sub	br3,temp
	breq	END_IR_ON3
	brcs	END_IR_ON3
	rjmp	RC_exit
END_IR_ON3:
	clr	br3
	rjmp	RC_exit

	;***   ***
IR_Off3:	
	mov	temp,br3
	cpi	temp,min_br
	brsh	END_IR_Off3	;    ,  
	ldi	temp,IR_step
	add	br3,temp	;  
	rjmp	RC_exit		; 
END_IR_Off3:
	clbr	mask,SYM3
	rjmp	RC_exit
	
;******************************************************************************	
PUP_4:
	cpi	Frame,4
	brne	PUP_5		;  ,  
	
	;***    ***
	clr	Frame		; ,   
	clbr	Flag1,Resiv_Complit;   
	rcall	Restore_10h	; 10  
	
	;***   ***
	tst	IR_cnt		;  , ,  
	brne	PUP_4_1		;   ?
	clr	temp		;  
	stbr	temp,SYM4	;   
	eor	Dir,temp	;
PUP_4_1:
	ldi	temp,IR_time	;   
	mov	IR_cnt,temp
	
	bbrs	Dir,SYM4,IR_Off4;    
	
	;***   ***
IR_ON4:
	stbr	mask,SYM4
	ldi	temp,IR_step
	sub	br4,temp
	breq	END_IR_ON4
	brcs	END_IR_ON4
	rjmp	RC_exit
END_IR_ON4:
	clr	br4
	rjmp	RC_exit

	;***   ***
IR_Off4:	
	mov	temp,br4
	cpi	temp,min_br
	brsh	END_IR_Off4	;    ,  
	ldi	temp,IR_step
	add	br4,temp	;  
	rjmp	RC_exit		; 
END_IR_Off4:
	clbr	mask,SYM4
	rjmp	RC_exit
	
;******************************************************************************	
PUP_5:
	cpi	Frame,5
	brne	PUP_6		;  ,  
	
	;***    ***
	clr	Frame		; ,   
	clbr	Flag1,Resiv_Complit;   
	rcall	Restore_10h	; 10  
	
	;***   ***
	tst	IR_cnt		;  , ,  
	brne	PUP_5_1		;   ?
	clr	temp		;  
	stbr	temp,SYM5	;   
	eor	Dir,temp	;
PUP_5_1:
	ldi	temp,IR_time	;   
	mov	IR_cnt,temp
	
	bbrs	Dir,SYM5,IR_Off5;    
	
	;***   ***
IR_ON5:
	stbr	mask,SYM5
	ldi	temp,IR_step
	sub	br5,temp
	breq	END_IR_ON5
	brcs	END_IR_ON5
	rjmp	RC_exit
END_IR_ON5:
	clr	br5
	rjmp	RC_exit

	;***   ***
IR_Off5:	
	mov	temp,br5
	cpi	temp,min_br
	brsh	END_IR_Off5	;    ,  
	ldi	temp,IR_step
	add	br5,temp	;  
	rjmp	RC_exit		; 
END_IR_Off5:
	clbr	mask,SYM5
	rjmp	RC_exit
	
;******************************************************************************	
PUP_6:
	cpi	Frame,0
	brne	PUP_7		;  ,  
	
	;***    ***
	clr	Frame		; ,   
	clbr	Flag1,Resiv_Complit;   
	rcall	Restore_10h	; 10  

	clr	mask		;  
	ser	Dir
	ldi	temp,min_br
	mov	br1,temp
	mov	br2,temp
	mov	br3,temp
	mov	br4,temp
	mov	br5,temp
	
	rjmp	RC_exit	
	
;******************************************************************************	

PUP_7:
	cpi	Frame,12
	brne	PUP_8		;  ,  
	
	;***    ***
	clr	Frame		; ,   
	clbr	Flag1,Resiv_Complit;   
	rcall	Restore_10h	; 10  

	stbr	Flag1,All_On		

PUP_8:
RC_exit:	
	
;******************************************************************************
;       INT0
;******************************************************************************
Phase0:
	bbrc	FLAG,end,Phase2
	in	temp,PIND
	sbr	temp,0b10001100	;    
	cpi	temp,0xFF
	brne	Phase1
	clbr	FLAG,auto
	clbr	FLAG,end
	clbr	FLAG,short
	clbr	FLAG,long
Phase1:
	rjmp	MA10	
	
Phase2:	
	bbrs	FLAG,auto,auto_short
	bbrs	FLAG,Short,Same0
	in	temp,PIND
	sbr	temp,0b10001100	;    
	cp	PrKey,temp
	breq	Same
NoSame:	
	mov	PrKey,temp
	ldi	temp,DebVal
	mov	DebTM,temp
	clbr	FLAG,NoFirst
	clbr	FLAG,short
	clbr	FLAG,long
	rjmp	MA10
Same:
	tst	DebTM		;  ?
	breq	Same0
	rjmp 	MA10
Same0:	
	bbrs	FLAG,Short,Sh_1
	bbrs	FLAG,Long,Lng_1
	
	in	temp,PIND
	sbr	temp,0b10001100	;    
	cpi	temp,0xFF
	brne	Same1
	rjmp	MA10		;  , 
Same1:		
	stbr	FLAG,Short	;     
	ldi	cnt,TimeShort	;     
	rjmp	MA10		; 
	
	
;******************************************************************************
;     
;******************************************************************************
Sh_1:
	tst	cnt		;    
	breq	ToLong		;    
	in	temp,PIND
	sbr	temp,0b10001100	;    
	cpi	temp,0xFF	;     
	brne	Sh_2		; ,   
	stbr	FLAG,auto	;
	clbr 	FLAG,short
Sh_2:	
	rjmp	MA10
ToLong:	
	ldi	temp,RepVal	; 
	mov	RepTM,temp
	clbr	FLAG,Short
	stbr	FLAG,Long
	rjmp	MA10
		
auto_short:
	tst	RepTM
	brne	MA10
	ldi	temp,RepVal	; 
	mov	RepTM,temp
	
	ldi	temp,TenVal_H	;  
	mov	TenH,temp
	ldi	temp,TenVal_M
	mov	TenM,temp
	ldi	temp,TenVal_L
	mov	TenL,temp	
COD0:
	cpi	PrKey,0b10111111;   	
	brne	COD1
	rcall	EXE1		;   
COD1:	
	cpi	PrKey,0b11011111
	brne	COD2
	rcall	EXE2
COD2:
	cpi	PrKey,0b11101111
	brne	COD3
	rcall	EXE3
COD3:
	cpi	PrKey,0b11111101
	brne	COD4
	rcall	EXE4
COD4:
	cpi	PrKey,0b11111110
	brne	COD5
	rcall	EXE5
COD5:			
	rjmp	MA50

;******************************************************************************
;     
;******************************************************************************
Lng_1:
	rjmp	auto_short

;******************************************************************************
;     
;******************************************************************************
MA10:
	tst	DebTM		; 
	breq	MA15		;    0,   
	dec	DebTM
MA15:
	tst	IR_cnt		;      
	breq	MA20		;   
	dec	IR_cnt		;   	
MA20:				
	tst	RepTM		; 
	breq	MA25
	dec	RepTM
MA25:				;   
	tst	cnt
	breq	MA30
	dec	cnt		
MA30:
	clr	temp		;  
	or	temp,TenH
	or	temp,TenM
	or	temp,TenL
	tst	temp
	breq	MA40		;    0,   
				; 
	ldi	temp,1		;    0,   
	sub	TenL,temp
	brcc	MA50
	sub	TenM,temp
	brcc	MA50
	sub	TenH,temp
	rjmp	MA50
MA40:				
	clr	mask		;  
	ser	Dir
	ldi	temp,min_br
	mov	br1,temp
	mov	br2,temp
	mov	br3,temp
	mov	br4,temp
	mov	br5,temp

MA50:	
	sbis	PIND,2		;   
	rjmp	MA50
	
	sbi	PORTB,1		;
	
	pop	temp
	out	SREG,pres
	
	in	temp1,SPL	;   
	inc	temp1		;
	inc	temp1		;
	out	SPL,temp1	;   2
	sei			; 
				;	
	rjmp	MainLoop	;   

;******************************************************************************
;     10       
;******************************************************************************
Restore_10h:
	ldi	temp,TenVal_H	;  
	mov	TenH,temp
	ldi	temp,TenVal_M
	mov	TenM,temp
	ldi	temp,TenVal_L
	mov	TenL,temp
	ret
