
.include "2313def.inc"

;******************************************************************************  
;   
;******************************************************************************  
.equ	DebVal	=2	;  
.equ	RepVal	=2	;  
.equ	TenVal_H=$36	; ,    
.equ	TenVal_M=$EE	;   
.equ	TenVal_L=$80	;
.equ	min_br	=230	; ,   ,   
.equ	TimeShort=50	;    = 0,5 
.equ	min_large=40	;     
.equ	max_large=130	;  .   
.equ	maxmax_large=230;  .   
.equ	System	=29	;   RC-5
.equ	IR_time	=100	;     .  
.equ	IR_step	=8	;     1  


;******************************************************************************  
;	Global Register Variables
;******************************************************************************  

.def	pres	=r1	;      
.def	br1	=r2	;  
.def	br2	=r3	;
.def	br3	=r4	;
.def	br4	=r5	;
.def	br5	=r6	;
.def	RepTM	=r7	; 
.def	DebTM	=r8	; 
.def	TenH	=r9	;  10  
.def	TenM	=r10	;  10  
.def	TenL	=r11	;  10  
.def	presIR	=r12	;       
.def	IR_cnt	=r13	;      
;.def		=r14	;
;.def		=r15	;

.def	temp	=r16
.def	cnt	=r17	;.  .
.def	FLAG	=r18	;  
 .equ All_first=0	;   "    "
 .equ NewPr	=1	;  
 .equ Long	=2	; "" 
 .equ Short	=3	; "" 
 .equ auto	=4	; 
 .equ NoFirst	=5	;     EXE
 .equ end	=6	;     
 .equ Resiv	=7	;   
.def	PrKey	=r19	;   
.def	mask	=r20	;  
.def	Dir	=r21	;  "-" 
.def	temp1	=r22	; 
.def	IRL	=r23	;    
.def	IRH	=r24	;    
.def	Frame	=r25	;  
.def	Flag1	=r26	;  
 .equ	LongPit	=0	;    
 .equ	Resiv_Complit=1	;    
 .equ	All_On	=2	;-   
 .equ	All_Off =3	;-   
;.def		=r27	;
;.def		=r28	;Y
;.def		=r29	;
;.def		=r30	;Z
;.def		=r31	;

;******************************************************************************  
;	Macros
;******************************************************************************
.macro 	clbr		;   
	cbr	@0,exp2(@1)
.endm
.macro	stbr		;   
	sbr	@0,exp2(@1)
.endm
.macro	bbrc		;     
	sbrs	@0,@1
	rjmp	@2
.endm
.macro	bbrs		;     
	sbrc	@0,@1
	rjmp	@2
.endm
.macro	bbic		;    I/O  
	sbis	@0,@1
	rjmp	@2
.endm
.macro	bbis		;    I/O  
	sbic	@0,@1 
	rjmp	@2
.endm
.macro	test
	sbi	PORTB,@0
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	cbi	PORTB,@0
.endm



;******************************************************************************
;   
;******************************************************************************
.DSEG
COD:	.byte 1		;   	

 
;******************************************************************************  
;	Interrupt Vectors
;******************************************************************************
.CSEG 
.org 0 
 
	rjmp	INIT		;Reset Handle
	rjmp	Phase		; 
	rjmp	IrDA		;  
.org 4
	rjmp	TCNT1_COMP	;  1

;******************************************************************************  
;	Program Execution Starts Here
;******************************************************************************

INIT:	ldi	temp,RAMEND	;Locate stack
	out	SPL,temp
	
	ldi	temp,0b00001010	; INT0   
	out	MCUCR,temp	; INT1   

	ldi	temp,0b11000000	;  INT0
	out	GIMSK,temp	;  INT1
	
	ldi	temp,0b01000000	;    TCNT1
	out	TIMSK,temp	
	
	clr	temp
	out	TCNT0,temp	; TCNT0
	out	TCNT1H,temp
	out	TCNT1L,temp	; TCNT1
	
	out	TCCR1B,temp	; TCNT1 
	ldi	temp,0b00000100
	out	TCCR0,temp	; TCNT0   CK/256
	
	ldi	temp,$01
	out	OCR1AH,temp
	ldi	temp,$20	;   3 mS  
	out	OCR1AL,temp	;  TCNT1
	
	clr	IRL		;  
	sbr	IRL,1
	clr	IRH
	clr	FLAG
	clr	Flag1
	clr	Frame
	
;	ldi	temp,39
;	out	UBRR,temp	; UART 9600 /
;	ldi	temp,0b00001000	
;	out	UCR,temp	;   USART

;	ldi	temp,$A0
;	out	UDR,temp
	
;******************************************************************************
;	Variables init
;******************************************************************************
	ldi	temp,min_br	;    
	mov	br1,temp
	mov	br2,temp
	mov	br3,temp
	mov	br4,temp
	mov	br5,temp
	
	clr	mask		;  
	ser	Dir
	clr	IR_cnt
	
	ldi	temp,TenVal_H	;  
	mov	TenH,temp
	ldi	temp,TenVal_M
	mov	TenM,temp
	ldi	temp,TenVal_L
	mov	TenL,temp	

	clr	IRH		;   
	ldi	IRL,0b00000001
	

;******************************************************************************  
;	Periphery setup
;******************************************************************************
;***   PORTB   ***

	ldi	temp,0b11111111
	out	DDRB,temp
	ldi	temp,0b00000111		
	out	PORTB,temp
.equ	LCD0	=0
.equ	LCD1	=1
.equ	LCD2	=2
.equ	SYM1	=3
.equ	SYM2	=4
.equ	SYM3	=5
.equ	SYM4	=6
.equ	SYM5	=7

;***   PORTD   ***

	ldi	temp,0b00000000
	out	DDRD,temp
	ldi	temp,0b01110111
	out	PORTD,temp
.equ	SW1	=6
.equ	SW2	=5
.equ	SW3	=4
.equ	SW4	=1
.equ	SW5	=0
;.equ	irda_D	=3

.include "RC-5.asm"
